<?php



require_once 'Classes/Model/Observation.php';



/**
 * @class ObservationSet
 *
 * This class represents an observation and a set of associated calibrations. These
 * calibrations will be within X minutes of the observation
 **/
class ObservationSet
{
  // PUBLIC

  public function __construct()
  {
    $this->observation = null;
    $this->calibrations = null;
    $this->observation_data = null;
    $this->scrunching_parameters = null;
  }

  public function SetObservation( $s_observation ) { $this->observation = $s_observation; }
  public function GetObservation() { return $this->observation; }

  //public function SetupObservationData( $s_obervation_data ) { $this->obsevation_data = $s_observation_data; }
  //public function GetObservationData() { return $this->observation_data; }

  public function SetCalibrations( $s_calibrations ) { $this->calibrations = $s_calibrations; }
  public function GetCalibrations() { return $this->calibrations; }
  
  public function SetScrunchingParameters( $s_scrunching_parameters ) { $this->scrunching_parameters = $s_scrunching_parameters; }
  public function GetScrunchingParameters() { return $this->scrunching_parameters; }
  
  //! This function creates the observation_data object and sets it up
  public function SetupObservationData()
  {
    $this->observation_data = new ObservationData();
    
    $this->observation_data->SetPath( $this->observation->GetFile() );
    $this->observation_data->SetScrunchingParameters( $this->scrunching_parameters );
  }
  
  public function EstimateDownloadableSize()
  {
    $dl_size = $this->observation_data->EstimateDownloadableSize();
    echo 'obs file size is ' . $dl_size . ' <br> ';
    foreach( $this->calibrations as $next_cal )
    {
      echo 'adding cal file with size ' . $next_cal->GetFile()->GetFileSize() . ' <br> ';
      $dl_size += $next_cal->GetFile()->GetFileSize();
    }
        
    return $dl_size;
  }

  // PRIVATE

  private $observation;
  private $calibrations;
  private $observation_data;
  private $scrunching_parameters;
};

